<?php
namespace bwdpdfx_ViewPdfClear_namespace;

use bwdpdfx_ViewPdfClear_namespace\PageSettings\Page_Settings;
define( "bwdpdfx_ASFSK_ASSETS_PUBLIC_DIR_FILE", plugin_dir_url( __FILE__ ) . "assets/public" );
define( "bwdpdfx_ASFSK_ASSETS_ADMIN_DIR_FILE", plugin_dir_url( __FILE__ ) . "assets/admin" );
class Classbwdpdfx_ViewPdfClear {

	private static $_instance = null;

	public static function instance() {
		if ( is_null( self::$_instance ) ) {
			self::$_instance = new self();
		}
		return self::$_instance;
	}

	public function bwdpdfx_admin_editor_scripts() {
		add_filter( 'script_loader_tag', [ $this, 'bwdpdfx_admin_editor_scripts_as_a_module' ], 10, 2 );
	}

	public function bwdpdfx_admin_editor_scripts_as_a_module( $tag, $handle ) {
		if ( 'bwdpdfx_ViewPdfClear_editor' === $handle ) {
			$tag = str_replace( '<script', '<script type="module"', $tag );
		}

		return $tag;
	}

	private function include_widgets_files() {
		require_once( __DIR__ . '/widgets/bwdpdfx-view-pdf-widgets.php' );
	}

	public function bwdpdfx_register_widgets() {
		// Its is now safe to include Widgets files
		$this->include_widgets_files();

		// Register WidgetsF
		\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Widgets\bwdpdfx_ViewPdfClear_widgets());
	}

	private function add_page_settings_controls() {
		require_once( __DIR__ . '/page-settings/bwdpdfx-view-pdf-manager.php' );
		new Page_Settings();
	}

	// Register Category
	function bwdpdfx_ViewPdfClear_add_elementor_widget_categories( $elements_manager ) {

		$elements_manager->add_category(
			'bwdpdfx-ViewPdfClear-category',
			[
				'title' => esc_html__( 'Clear PDF View', 'bwdpdfx-pdf-view' ),
				'icon' => 'eicon-person',
			]
		);
	}

	//css-js-link-here
	public function bwdpdfx_all_assets_for_the_public(){
		wp_enqueue_script( 'bwdpdfx-ViewPdfClear-pdf', plugin_dir_url( __FILE__ ) . 'assets/public/js/pdf.js', array('jquery'), '1.3', true );
		wp_enqueue_script( 'bwdpdfx-ViewPdfClear-main', plugin_dir_url( __FILE__ ) . 'assets/public/js/main.js', array('jquery'), '1.3', true );
		$all_css_file = array(
			'bwdpdfx-ViewPdfClear-plugin-main' => array('bwdpdfx-ViewPdfClear_css_path_define'=>bwdpdfx_ASFSK_ASSETS_PUBLIC_DIR_FILE . '/css/main.css'),
        );
        foreach($all_css_file as $handle => $fileinfo){
            wp_enqueue_style( $handle, $fileinfo['bwdpdfx-ViewPdfClear_css_path_define'], null, '1.3', 'all');
        }

	}

	//admin-icon
	public function bwdpdfx_all_assets_for_elementor_editor_admin(){
		$all_css_js_file = array(
            'bwdpdfx-ViewPdfClear-admin-main' => array('bwdpdfx_path_admin_define'=>bwdpdfx_ASFSK_ASSETS_ADMIN_DIR_FILE . '/css/icon.css'),
        );
        foreach($all_css_js_file as $handle => $fileinfo){
            wp_enqueue_style( $handle, $fileinfo['bwdpdfx_path_admin_define'], null, '1.3', 'all');
        }
	}

	public function __construct() {

		// For public assets
		add_action('wp_enqueue_scripts', [$this, 'bwdpdfx_all_assets_for_the_public']);

		// For Elementor Editor
		add_action('elementor/editor/before_enqueue_scripts', [$this, 'bwdpdfx_all_assets_for_elementor_editor_admin']);

		// Register Category
		add_action( 'elementor/elements/categories_registered', [ $this, 'bwdpdfx_ViewPdfClear_add_elementor_widget_categories' ] );

		// Register widgets
		add_action( 'elementor/widgets/widgets_registered', [ $this, 'bwdpdfx_register_widgets' ] );

		// Register editor scripts
		add_action( 'elementor/editor/after_enqueue_scripts', [ $this, 'bwdpdfx_admin_editor_scripts' ] );

		$this->add_page_settings_controls();
	}
}

// Instantiate Plugin Class
Classbwdpdfx_ViewPdfClear::instance();